<?php

declare(strict_types=1);

namespace Drupal\group_test_plugin\Hook;

use Drupal\Core\Hook\Attribute\Hook;
use Drupal\group_test_plugin\Entity\GroupedUserSpecific;

/**
 * Entity hook implementations for Group test plugin.
 */
final class EntityHooks {

  /**
   * Implements hook_entity_bundle_info_alter().
   */
  #[Hook('entity_bundle_info_alter')]
  public function entityBundleInfoAlter(&$bundles): void {
    if (!empty($GLOBALS['specific_bundle_id'])) {
      $bundles['group_relationship'][$GLOBALS['specific_bundle_id']]['class'] = GroupedUserSpecific::class;
    }
  }

}
